#!/usr/bin/perl

#use strict;
#use warnings;
#use Math::Combinatorics;
use File::Copy;
use utf8; 

$lib_file = "libS.pl";
require $lib_file;

my $input= "lcs"; # metric:  LCS 

####### Reading the input files ########

$outdir=$res_dir."/".$dataset."/string_similarities/";
system("mkdir -p $outdir");

my (@text1,@text2);
$train = $data_dir."/".$dataset.".train";
$test = $data_dir."/".$dataset.".test";

open(F1,$train);
@train = <F1>;
close(F1);

for($i=0; $i<scalar(@train); $i++){
	$line = $train[$i];
	@line = split(/\,/,$line);
	$rule = shift(@line);
	foreach $frag (@line){ push(@text1,$frag); }
}

open(F2,$test);
@text2 = <F2>;
close(F2);

$l1=@text1;
$l2=@text2;
my ($temp1,$temp2)=("","");

print $l1." +++ ".$l2."\n";
$file = $outdir."/".uc($input).".csv";

open(OUT,">$file");
		
for($i=0;$i<$l2;$i++) {
	for($n=0; $n<$l1; $n++){
		($temp2,$temp1)=($text2[$i],$text1[$n]);
		if ($temp1 ne '' && $temp2 ne ''){
			
			my @s1 = split /\s+/ => $temp1; # seperate words of sentences
			my @s2 = split /\s+/ => $temp2; # seperate words of sentences
			my $size1=@s1;
			my $size2=@s2;
			my $words=0;
			my @tmp3;
				
			$seq= LCS($temp1, $temp2);
			$seq=~s/^\s+//g;
			@tmp3 = split /\s+/ => $seq;
			$words= @tmp3; ##take the size in words of the returned sequence
			#---compute scores---
			if($words==0){$score = 0; push(@score,$score);}
			elsif(($size1==0)||($size2==0)){$score = 0; push(@score,$score);}
			else{
				$score=$words/($size1+$size2);
				$score=sprintf("%.4f", $score);
				push(@score,$score);
			}
		}
	}
	chomp($text2[$i]);
	
	#~ print $text2[$i]."---".$text1[$n]."\n";exit;
	print OUT $text2[$i].",";
	for($j=0; $j<$l1; $j++){
		chomp($text1[$j]);
		if($j==$#score){print OUT $text1[$j].",".$score[$j]."\n";}
		else{print OUT $text1[$j].",".$score[$j]."\,";}
	}
	@score = ();
}
@text1 = ();
@text2 = ();

##################################################################################################
# SUBROUTINES
##################################################################################################



	sub LCS {
		my $a = $_[0];
		my $b = $_[1];
		my $S = [];   # An array of scores
		my $R = [];   # An array of backtracking arrows
		my $W = [];  # An aray holding the length of consecutive matches at position i,i-1
		my $n = length($a);
		my $m = length($b);
	
		# We need to work in letters, not in strings.  This is a simple way
		# to turn a string of letters into an array of letters.HD 
		my @a = split /\s+/ => $a; # seperate words of sentences
		my @b = split /\s+/ => $b;

		# These are "constants" which indicate a direction in the backtracking array.
		my $NEITHER     =  0;
		my $UP          = 1;
		my $LEFT        = 2;
	
		my $UP_AND_LEFT = 3;
		my $k =0;
	  
		# It is important to use <=, not <.  The next two for-loops are initialization
		for(my $ii = 0; $ii <= $n; ++$ii) { 
			$S->[$ii][0] = 0;
			$R->[$ii][0] = $UP;
			$W->[$ii][0] = 0;
		}
	
		for(my $jj = 0; $jj <= $m; ++$jj) { 
			$S->[0][$jj] = 0;
			$R->[0][$jj] = $LEFT;
			$W->[0][$jj] = 0;
		}

		# This is the main dynamic programming loop that computes the score and
		# backtracking arrays.
	
		for(my $ii = 1; $ii <= $n; ++$ii) {
			for(my $jj = 1; $jj <= $m; ++$jj) { 
			
				if($a[$ii-1] eq $b[$jj-1]){
				$k=$W->[$ii-1][$jj-1];
				}
			
				($S->[$ii][$jj], $R->[$ii][$jj], $W->[$ii][$jj]) = ($a[$ii-1] eq $b[$jj-1]) ?
				($S->[$ii-1][$jj-1] + fk_sqrt($k+1)-fk_sqrt($k), $UP_AND_LEFT, $k+1) :
				($S->[$ii-1][$jj-1] + 0, $NEITHER, 0);
				
				($S->[$ii][$jj], $R->[$ii][$jj], $W->[$ii][$jj]) = $S->[$ii-1][$jj] >= $S->[$ii][$jj] ?
				($S->[$ii-1][$jj], $UP, 0) : 
				($S->[$ii][$jj], $R->[$ii][$jj], 0);

				($S->[$ii][$jj], $R->[$ii][$jj], $W->[$ii][$jj]) = $S->[$ii][$jj-1] >= $S->[$ii][$jj] ?
				($S->[$ii][$jj-1], $LEFT, 0) : 
				($S->[$ii][$jj], $R->[$ii][$jj], 0);
			}
		}

		# The length of the longest substring is $S->[$n][$m]
		$ii = $n; 
		$jj = $m;
		my $lcs = '';

		# Trace the backtracking matrix.
		while( $ii > 0 || $jj > 0 ) {
			if( $R->[$ii][$jj] == $UP_AND_LEFT ) {
				$ii--;
				$jj--;
				$lcs = $a[$ii]." ".$lcs;
			} 

			elsif( $R->[$ii][$jj] == $UP ) {
				$ii--;
			}

			elsif( $R->[$ii][$jj] == $LEFT ) {
				$jj--;
			}

			else {
				die("Uninitialized arrow at ($ii, $jj): $S->[$ii][$jj] / $R->[$ii][$jj]\n");
			}
		}

		return $lcs;
	}	#end of LCS

	sub fk_sqrt{
		$k_val=$_[0];
		return sqrt($k_val);
	}
