#!/usr/bin/perl

use strict;
use warnings;

open GRND,shift @ARGV||die $!;
open HYP,shift @ARGV||die $!;


my $JUNK="<JUNK>";
my %hyp;
my %grnd;
my %grnd_rules;
#my %grnd_junks;

while(my $line=<GRND>){
	chomp $line;
	my @items=split ",",$line;
	foreach my $i (1..$#items){
		$grnd{$items[0]}{$items[$i]}=1;
		$grnd_rules{$items[$i]}=1;
	}
}

my ($unw_prec,$unw_rec,$weighted_prec,$weighted_rec)=(0,0,0,0);
while(my $line=<HYP>){
	chomp $line;
	my @items=split ",",$line;
	next if $items[0] eq $JUNK;
	my $rule_correct=0;
	foreach my $i (1..$#items){
		#print "$items[0] $items[$i]\n";
		if (exists $grnd{$items[0]}{$items[$i]}){
					$rule_correct++;
		}
	}
	#print "correct are $rule_correct\n";	
	my $precision=$rule_correct/$#items;
	my $recall=$rule_correct/scalar (keys %{$grnd{$items[0]}});
	#printf ("For rule %s Pr Rec: %.2f %.2f\n",$items[0],$precision,$recall);
	$unw_prec+=$precision;
	$unw_rec+=$recall;
	$weighted_prec+=$precision * scalar (keys %{$grnd{$items[0]}});
	$weighted_rec+=$recall * scalar (keys %{$grnd{$items[0]}});
	
}
	
	my $normalize=0;
	my $num_of_rules=0;
	foreach my $rule (keys %grnd){
		next if $rule eq $JUNK;
		$normalize+= scalar keys %{$grnd{$rule}};
		$num_of_rules+=1;
	}
	$weighted_prec/=$normalize;
	$weighted_rec/=$normalize;
	$unw_prec/=$num_of_rules;
	$unw_rec/=$num_of_rules;
	my $fmeasure_w=2*$weighted_prec*$weighted_rec/($weighted_rec+$weighted_prec);
	my $fmeasure_unw=2*$unw_prec*$unw_rec/($unw_rec+$unw_prec);
	printf "For all rules (weighted): Precision: %.2f Recall: %.2f F-measure: %.2f\n",$weighted_prec, $weighted_rec, $fmeasure_w;
	printf "For all rules (unweighted): Precision: %.2f Recall: %.2f F-measure: %.2f\n",$unw_prec, $unw_rec, $fmeasure_unw;

